## ros-noetic-reach 1.5.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

# Extract package name and version from package.xml
find_package(ros_industrial_cmake_boilerplate REQUIRED)
extract_package_metadata(pkg)
project(${pkg_extracted_name} VERSION ${pkg_extracted_version} LANGUAGES CXX)

option(BUILD_PYTHON "Build Python bindings" ON)

# Python dependencies need to be found first
if(BUILD_PYTHON)
  find_package(Python REQUIRED COMPONENTS Interpreter Development)
  find_package(PythonLibs 3 REQUIRED)
  find_package(Boost REQUIRED COMPONENTS python numpy)
endif()

find_package(Boost REQUIRED COMPONENTS serialization program_options)
find_package(Eigen3 REQUIRED)
find_package(PCL REQUIRED COMPONENTS io search)
find_package(yaml-cpp REQUIRED)
find_package(boost_plugin_loader REQUIRED)

find_package(OpenMP)
if(OPENMP_FOUND)
  if(NOT TARGET OpenMP::OpenMP_CXX)
    find_package(Threads REQUIRED)
    add_library(OpenMP::OpenMP_CXX IMPORTED INTERFACE)
    set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_COMPILE_OPTIONS ${OpenMP_CXX_FLAGS})
    # Only works if the same flag is passed to the linker; use CMake 3.9+ otherwise (Intel, AppleClang)
    set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_LINK_LIBRARIES ${OpenMP_CXX_FLAGS} Threads::Threads)

  endif()
endif()

set(TARGETS "")

# Interface library
add_library(${PROJECT_NAME}_interface INTERFACE)
target_include_directories(${PROJECT_NAME}_interface INTERFACE "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
                                                               "$<INSTALL_INTERFACE:include>")
target_include_directories(${PROJECT_NAME}_interface INTERFACE ${PCL_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME}_interface INTERFACE Eigen3::Eigen Boost::serialization yaml-cpp)
target_compile_definitions(
  ${PROJECT_NAME}_interface
  INTERFACE DISPLAY_SECTION="disp"
            EVALUATOR_SECTION="eval"
            IK_SOLVER_SECTION="ik"
            LOGGER_SECTION="logger"
            TARGET_POSE_GEN_SECTION="pose"
            BUILD_PYTHON=${BUILD_PYTHON})
target_cxx_version(${PROJECT_NAME}_interface INTERFACE VERSION 14)
list(APPEND TARGETS ${PROJECT_NAME}_interface)

# Reach Study Library
add_library(
  ${PROJECT_NAME} SHARED
  src/utils.cpp
  src/plugin_utils.cpp
  src/types.cpp
  src/reach_visualizer.cpp
  src/reach_study.cpp
  src/reach_study_comparison.cpp
  # Implementations
  src/plugins/multiplicative_evaluator.cpp
  src/plugins/point_cloud_target_pose_generator.cpp
  src/plugins/console_logger.cpp
  src/plugins/boost_progress_console_logger.cpp
  src/plugins/no_op.cpp)
target_link_libraries(
  ${PROJECT_NAME}
  PUBLIC ${PROJECT_NAME}_interface
         boost_plugin_loader::boost_plugin_loader
         ${PCL_LIBRARIES}
         OpenMP::OpenMP_CXX)
target_compile_definitions(${PROJECT_NAME} PUBLIC SEARCH_LIBRARIES_ENV="REACH_PLUGINS"
                                                  PLUGIN_LIBRARIES="${PROJECT_NAME}_plugins")
target_cxx_version(${PROJECT_NAME} PUBLIC VERSION 14)
list(APPEND TARGETS ${PROJECT_NAME})

# Plugins Library
add_library(${PROJECT_NAME}_plugins SHARED src/plugins/plugins.cpp)
target_link_libraries(
  ${PROJECT_NAME}_plugins
  PUBLIC ${PROJECT_NAME}
         Eigen3::Eigen
         ${PCL_LIBRARIES}
         boost_plugin_loader::boost_plugin_loader)
target_cxx_version(${PROJECT_NAME}_plugins PUBLIC VERSION 14)
list(APPEND TARGETS ${PROJECT_NAME}_plugins)

# Reach Study App
add_executable(${PROJECT_NAME}_app src/app/reach_study.cpp)
target_link_libraries(${PROJECT_NAME}_app PRIVATE ${PROJECT_NAME} Boost::program_options)
target_cxx_version(${PROJECT_NAME}_app PUBLIC VERSION 14)
list(APPEND TARGETS ${PROJECT_NAME}_app)

# Data Loader App
add_executable(${PROJECT_NAME}_data_loader src/app/data_loader.cpp)
target_link_libraries(${PROJECT_NAME}_data_loader PRIVATE ${PROJECT_NAME} Boost::program_options)
target_cxx_version(${PROJECT_NAME}_data_loader PUBLIC VERSION 14)
list(APPEND TARGETS ${PROJECT_NAME}_data_loader)

if(BUILD_PYTHON)
  message("Building Python bindings")
  add_subdirectory(src/python)
  install(DIRECTORY scripts/ DESTINATION bin)
endif()

# ######################################################################################################################
# TEST ##
# ######################################################################################################################

if(ENABLE_TESTING)
  enable_testing()
  add_run_tests_target(ENABLE ${ENABLE_RUN_TESTING})
  add_subdirectory(test)
endif()

# ######################################################################################################################
# INSTALL ##
# ######################################################################################################################

install(DIRECTORY include/${PROJECT_NAME}/ DESTINATION include/${PROJECT_NAME})

# Package configuration
configure_package(
  NAMESPACE reach
            DEPENDENCIES
            "Boost REQUIRED COMPONENTS serialization program_options"
            "PCL REQUIRED COMPONENTS io search"
            Eigen3
            yaml-cpp
            boost_plugin_loader
            OpenMP
  TARGETS ${TARGETS})

=== test/CMakeLists.txt ===
find_gtest()

add_executable(${PROJECT_NAME}_utest reach_study_utest.cpp)
target_link_libraries(${PROJECT_NAME}_utest PRIVATE ${PROJECT_NAME} GTest::GTest GTest::Main)
target_compile_definitions(${PROJECT_NAME}_utest
                           PRIVATE TEST_CONFIG_FILE="${CMAKE_CURRENT_SOURCE_DIR}/reach_study.yaml")
target_cxx_version(${PROJECT_NAME}_utest PUBLIC VERSION 14)
add_dependencies(run_tests ${PROJECT_NAME}_utest)
add_gtest_discover_tests(${PROJECT_NAME}_utest)

install(
  TARGETS ${PROJECT_NAME}_utest
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

install(FILES part.pcd reach_study.yaml DESTINATION share/${PROJECT_NAME}/test)

=== src/python/CMakeLists.txt ===
# Add Python libraries
python_add_library(${PROJECT_NAME}_python MODULE python_bindings.cpp)
target_include_directories(${PROJECT_NAME}_python PRIVATE ${PYTHON_INCLUDE_DIRS})
target_link_libraries(
  ${PROJECT_NAME}_python
  PRIVATE ${PROJECT_NAME}
          Boost::python
          Boost::numpy
          ${PYTHON_LIBRARIES})
target_compile_definitions(${PROJECT_NAME}_python PRIVATE MODULE_NAME=${PROJECT_NAME})
set_target_properties(${PROJECT_NAME}_python PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
target_cxx_version(${PROJECT_NAME}_python PUBLIC VERSION 14)

execute_process(
  COMMAND "${Python_EXECUTABLE}" -c "if True:
    from distutils import sysconfig as sc
    print(sc.get_python_lib(prefix='', plat_specific=True))"
  OUTPUT_VARIABLE PYTHON_SITE
  OUTPUT_STRIP_TRAILING_WHITESPACE)

install(TARGETS ${PROJECT_NAME}_python DESTINATION ${CMAKE_INSTALL_PREFIX}/${PYTHON_SITE})

=== debian/changelog ===
ros-noetic-reach (1.5.2-1focal) focal; urgency=high

  * Updated install of python module (#63 <https://github.com/marip8/reach/issues/63>)
  * Contributors: Michael Ripperger

 -- Michael Ripperger <michael.ripperger@swri.org>  Thu, 07 Sep 2023 05:00:00 -0000

ros-noetic-reach (1.5.1-1focal) focal; urgency=high

  * fix bools in yaml in Python (#59 <https://github.com/marip8/reach/issues/59>)
  * Contributors: Marc Bestmann

 -- Michael Ripperger <michael.ripperger@swri.org>  Wed, 16 Aug 2023 05:00:00 -0000

ros-noetic-reach (1.5.0-1focal) focal; urgency=high

  * Added ability to specify heat map color range (#58 <https://github.com/marip8/reach/issues/58>)
  * Contributors: Marc Bestmann

 -- Michael Ripperger <michael.ripperger@swri.org>  Fri, 28 Jul 2023 05:00:00 -0000

ros-noetic-reach (1.4.0-1focal) focal; urgency=high

  * Exposed relevant compile definitions for plugins to the Python interface (#57 <https://github.com/marip8/reach/issues/57>)
  * Contributors: Michael Ripperger

 -- Michael Ripperger <michael.ripperger@swri.org>  Thu, 13 Jul 2023 05:00:00 -0000

ros-noetic-reach (1.3.2-1focal) focal; urgency=high

  * Updated badges in README; added table of supported distros (#56 <https://github.com/marip8/reach/issues/56>)
  * Removed -dev libraries before running unit tests in CI (#55 <https://github.com/marip8/reach/issues/55>)
  * Updated CI configuration to be ROS-independent (#54 <https://github.com/marip8/reach/issues/54>)
  * Update to later version of RICB that adds hook for PYTHONPATH (#51 <https://github.com/marip8/reach/issues/51>)
  * Added colcon hook for setting the PYTHONPATH environment variable (#50 <https://github.com/marip8/reach/issues/50>)
  * Minor Updates (#48 <https://github.com/marip8/reach/issues/48>)
    * Added virtual destructors
    * Compile Python bindings with c++14
    * Change comparison operator for clang-tidy
  * Contributors: Michael Ripperger

 -- Michael Ripperger <michael.ripperger@swri.org>  Thu, 13 Jul 2023 05:00:00 -0000

ros-noetic-reach (1.3.1-1focal) focal; urgency=high

  * fix parallelization error of omp parallel (#47 <https://github.com/marip8/reach/issues/47>)
  * Contributors: Marc Bestmann

 -- Michael Ripperger <michael.ripperger@swri.org>  Wed, 14 Jun 2023 05:00:00 -0000

ros-noetic-reach (1.3.0-1focal) focal; urgency=high

  * Initial IK seed (#46 <https://github.com/marip8/reach/issues/46>)
    * add option to specify initial IK seed
    * refactor based on PR comments
    * improve reading of seed parameter from yaml
  * Contributors: Marc Bestmann

 -- Michael Ripperger <michael.ripperger@swri.org>  Tue, 13 Jun 2023 05:00:00 -0000

ros-noetic-reach (1.2.0-1focal) focal; urgency=high

  * Exposed plugin implementations for linking by downstream projects (#45 <https://github.com/marip8/reach/issues/45>)
  * Contributors: Michael Ripperger

 -- Michael Ripperger <michael.ripperger@swri.org>  Thu, 11 May 2023 05:00:00 -0000

ros-noetic-reach (1.1.0-1focal) focal; urgency=high

  * Move ROS1 components (#44 <https://github.com/marip8/reach/issues/44>)
    * Removed reach_ros directory
    * Flattened reach package
    * Updated CI config file
    * Added demo GIF and README
    * Fixed table of contents; added references to ROS repos; removed section on ROS-specific usage and demos
    * Changes to support ROS2
    * Updated dependencies
    * Remove reach_ros from plugins target compile definitions
    * Added colcon package file
  * Contributors: Michael Ripperger

 -- Michael Ripperger <michael.ripperger@swri.org>  Wed, 10 May 2023 05:00:00 -0000

ros-noetic-reach (1.0.0-1focal) focal; urgency=high

  * Added Python interface (#38 <https://github.com/ros-industrial/reach/issues/38>)
  * Updated to later version of plugin loader (#39 <https://github.com/ros-industrial/reach/issues/39>)
  * Refactored repository into ROS-independent core package and ROS-based plugin implementation package (#37 <https://github.com/ros-industrial/reach/issues/37>)
  * Contributors: Michael Ripperger, Collin Thornton

 -- Michael Ripperger <michael.ripperger@swri.org>  Tue, 06 Dec 2022 06:00:00 -0000

ros-noetic-reach (0.2.2-1focal) focal; urgency=high

  * Create nested results directories if they do not exist (#34 <https://github.com/marip8/reach/issues/34>)
  * Contributors: Michael Ripperger

 -- Michael Ripperger <michael.ripperger@swri.org>  Wed, 24 Aug 2022 05:00:00 -0000

ros-noetic-reach (0.2.1-1focal) focal; urgency=high



 -- Michael Ripperger <michael.ripperger@swri.org>  Fri, 22 Jul 2022 05:00:00 -0000

ros-noetic-reach (0.2.0-1focal) focal; urgency=high

  * Various Updates (#29 <https://github.com/marip8/reach/issues/29>)
    * Change FLANN search tree to PCL kd-tree; update nearest neighbors search; parallelize with hardware concurrency
    * Update to use non-deprecated IK solve function
    * Use Eigen vectorized array product rather than for loop
    * Support manipulability calculation for subset of dimensions
    * Added plugin for evaluating manipulability ratio
    * Simplified and vectorized joint penalty evaluator
    * Updated README
    * Updated unit test
  * Incorporated heat map coloring to rviz markers (#30 <https://github.com/marip8/reach/issues/30>)
    * Incorporated heat map coloring to rviz markers
    * Fixed formatting on heat map rviz marker code
    * Minor updates
    Co-authored-by: David Spielman <mailto:david.spielman@swri.org>
    Co-authored-by: Michael Ripperger <mailto:michael.ripperger@swri.org>
  * Contributors: David Spielman, Michael Ripperger

 -- Michael Ripperger <michael.ripperger@swri.org>  Fri, 22 Jul 2022 05:00:00 -0000

ros-noetic-reach (0.1.1-1focal) focal; urgency=high



 -- Michael Ripperger <michael.ripperger@swri.org>  Thu, 07 Jul 2022 05:00:00 -0000

ros-noetic-reach (0.1.0-1focal) focal; urgency=high

  * Reverted reach_core version before releasing packages


=== debian/control ===
Source: ros-noetic-reach
Section: misc
Priority: optional
Maintainer: Michael Ripperger <michael.ripperger@swri.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libeigen3-dev, libgtest-dev <!nocheck>, libomp-dev, libpcl-dev, libyaml-cpp-dev, ros-noetic-boost-plugin-loader, ros-noetic-ros-industrial-cmake-boilerplate
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-reach
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, libomp-dev, libpcl-dev, libyaml-cpp-dev, ros-noetic-boost-plugin-loader, ros-noetic-ros-industrial-cmake-boilerplate
Description: The reach package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-reach//opt/ros/noetic/lib/:$(CURDIR)/debian/ros-noetic-reach//opt/ros/noetic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
